; Disassembly of the file "Chicken (The Bit Fiddlers).bin"
; Originally loaded by BALLY-, then ASTRO-Basic program(s)
; by BIT FIDDLERS Software, hacked to run as a cartridge.
;
; CPU Type: Z80 for Bally Astrocade Home Library Computer
;
; Created with dZ80 2.0 using RCD's script "BallyHVG.LUA"
;
; Assembles correctly with zmac -i -m CHICKEN!.asm THEN do
; fix: Move block from $2000 to $0030 and trim down to 4K
;
; Wednesday, 31 of July 2013 at 01:39 AM by Richard Degler
;

        NOLIST
        INCLUDE "HVGLIB.H"

; Variable section mixed in with code below in Screen RAM
;

        LIST
        ORG     FIRSTC

; L2000:
        JP      L2003           ; decimal 195 AutoStart sentinel

; ... loader stub, only used ONCE
L2003:  LD      SP,$4FFE        ; set Stack Pointer to RAM top - 2
        SYSTEM  INTPC           ; UPI INTerPret with Context create
        DO      SETOUT          ; UPI SET some OUTput ports
        DB      $82             ; ... VERBL*2 = 130 for 65 pixel Lines
        DB      $2A             ; ... HORCB/4 = 42 for Left Colors only
        DB      $08             ; ... INMOD = 8 for Screen Interrupts
        ;
        DO      COLSET          ; UPI COLors SET for White background
        DW      L202C           ; ... Table Address = 8236
        ;
        DO      MOVE            ; UPI MOVE block transfer
        DW      NORMEM          ; ... Destination Address = 16384
        DW      $0FCF           ; ... Byte Count = 4047
        DW      L2030           ; ... Source Address = 8240
        ;
        DO      ACTINT          ; UPI ACTivate sub timer INTerrupts
        ;
        DO      PAWS            ; UPI PAUSE for 4.25 seconds
        DB      $FF             ; ... Interrupts = 255
        ;
        DO      COLSET          ; UPI COLors SET for Green background
        DW      L2028           ; ... Table Address = 8232
        ;
        DO      PAWS            ; UPI PAUSE for 2+ second
        DB      $7F             ; ... Interrupts = 127
        ;
        DO      COLSET          ; UPI COLors SET for Dark Red background
        DW      L2027           ; ... Table Address = 8231
        ;
        DO      PAWS            ; UPI PAUSE for 1 second
        DB      $3F             ; ... Interrupts = 63
        ;
        DONT    XINTC           ; UPI eXit INTerpreter with Context
        ;
        JP      L4A28           ; to RAM copy of Chicken! machine code

; COLor TABles
L2027:  DB      $00             ; COLor 3 Left = Black for Blacks and Reds

L2028:  DB      $01             ; COLor 3 Left = Darkest Gray
        DB      $72             ; COLor 2 Left = Darker Red
        DB      $7C             ; COLor 1 Left = Dark Red
        DB      $86             ; COLor 0 Left = Green (COLor Right not used)

L202C:  DB      $00             ; COLor 3 Left = Black
        DB      $05             ; COLor 2 Left = Dark Gray
        DB      $06             ; COLor 1 Left = Light Gray
        DB      $07             ; COLor 0 Left = White (COLor Right not used)

L2030:  ; COPY from here to end into RAM, new location for Labels used
        ORG     NORMEM
; note: first 2600 bytes are the BIT FIDDLERS "Chicken!" 2000-baud Load Screen
L4000:  DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $EA,$AA,$AA,$AA,$B5,$C0,$03,$57,$AA,$AA,$AA,$AA,$ED,$FD,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$C0,$C0,$D5,$55,$55,$55,$55,$55,$57
        DB      $EA,$AA,$AA,$AA,$B5,$C0,$03,$D7,$AA,$AA,$AA,$BA,$ED,$FD,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$C0,$30,$35,$55,$55,$55,$55,$55,$57
        DB      $EB,$EA,$AB,$FF,$FF,$00,$00,$FE,$AA,$AF,$FF,$FA,$ED,$FB,$55,$55,$55,$55,$55,$55,$55,$55,$55,$5F,$FD,$55,$FF,$FF,$FF,$D5,$5F,$F0,$0C,$0D,$55,$55,$55,$55,$55,$57
        DB      $EA,$AF,$AD,$55,$5F,$FC,$0F,$AA,$AF,$FD,$55,$7F,$AD,$FF,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$5C,$30,$03,$0F,$D5,$55,$55,$55,$55,$57
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$F5,$FF,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$57,$0C,$3F,$F0,$35,$55,$55,$55,$55,$57
        DB      $D5,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$5D,$FF,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$57,$CF,$C3,$FC,$0D,$55,$55,$55,$55,$57
        DB      $D5,$55,$55,$55,$55,$55,$55,$5F,$FF,$55,$5F,$D5,$DD,$FF,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$7C,$F0,$0C,$00,$FD,$55,$55,$55,$55,$57
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$D7,$5D,$FF,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$C3,$00,$C0,$00,$35,$55,$55,$55,$55,$57
        DB      $D5,$55,$55,$FD,$55,$55,$55,$57,$FF,$55,$55,$55,$DD,$FF,$55,$55,$55,$55,$55,$55,$FF,$FF,$FF,$55,$F5,$7F,$FF,$FF,$FF,$D7,$0C,$03,$03,$FF,$D5,$55,$55,$55,$55,$57
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$DD,$FE,$D5,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$57,$F0,$30,$0F,$F7,$D5,$55,$55,$55,$55,$57
        DB      $EA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AB,$FD,$FE,$D5,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$5C,$30,$C0,$FF,$FF,$F5,$55,$55,$55,$55,$57
        DB      $FF,$FF,$FF,$EA,$BF,$FF,$FF,$FF,$FF,$FE,$AA,$AB,$75,$FE,$D5,$55,$55,$55,$55,$5F,$FF,$FF,$FF,$D5,$55,$55,$55,$55,$55,$73,$C0,$03,$0F,$FF,$F5,$55,$55,$55,$55,$57
        DB      $FF,$FF,$FF,$EA,$BF,$FF,$FF,$FF,$FF,$FF,$AA,$AB,$75,$FE,$D5,$7F,$FF,$FF,$F5,$70,$00,$00,$00,$3F,$55,$55,$55,$55,$55,$7C,$30,$0C,$30,$FF,$D5,$55,$55,$55,$55,$57
        DB      $FF,$FF,$FF,$EA,$BF,$FF,$FF,$FF,$FF,$FE,$AA,$AB,$75,$FE,$B5,$55,$55,$55,$55,$5F,$03,$FF,$00,$00,$D5,$55,$55,$55,$57,$C3,$00,$30,$C3,$03,$55,$55,$55,$55,$55,$57
        DB      $EA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AB,$75,$FE,$B5,$55,$55,$55,$55,$55,$FF,$00,$FF,$00,$35,$55,$55,$55,$7C,$3C,$03,$30,$0C,$30,$D5,$55,$55,$55,$55,$57
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FD,$75,$FA,$ED,$55,$55,$55,$55,$55,$57,$FC,$00,$30,$0D,$55,$55,$57,$C3,$C0,$30,$30,$0C,$30,$D5,$55,$55,$55,$55,$57
        DB      $FF,$FF,$FF,$D5,$55,$55,$55,$55,$55,$55,$57,$55,$D5,$FA,$BD,$55,$55,$55,$55,$55,$5F,$03,$FF,$0F,$03,$55,$55,$5C,$3C,$30,$00,$C0,$03,$03,$55,$55,$55,$55,$55,$57
        DB      $FF,$FF,$FF,$D5,$55,$55,$55,$55,$55,$55,$57,$55,$D5,$FF,$BD,$57,$FF,$D5,$7F,$FD,$57,$F0,$03,$C0,$C0,$FF,$FD,$5C,$C3,$00,$03,$00,$3F,$FF,$D5,$55,$55,$55,$55,$57
        DB      $FF,$FF,$FF,$D5,$55,$55,$55,$55,$55,$55,$57,$55,$D5,$FF,$ED,$55,$55,$55,$55,$55,$55,$7F,$FC,$3C,$30,$00,$0F,$FF,$C0,$C0,$3C,$00,$FF,$00,$35,$55,$55,$55,$55,$57
        DB      $FF,$FF,$FF,$D5,$55,$55,$55,$55,$55,$55,$57,$55,$D5,$FF,$FD,$55,$55,$55,$55,$55,$55,$C0,$03,$F3,$C0,$00,$00,$00,$30,$00,$0C,$03,$FF,$F0,$35,$55,$55,$55,$55,$57
        DB      $FF,$FF,$FF,$D5,$55,$55,$55,$55,$55,$55,$57,$55,$D5,$FF,$FD,$55,$55,$55,$55,$55,$55,$7F,$F0,$03,$00,$00,$00,$00,$00,$00,$0C,$03,$FF,$0C,$35,$55,$55,$55,$55,$57
        DB      $FF,$FF,$FF,$D5,$55,$55,$55,$55,$55,$55,$57,$55,$D5,$FF,$F5,$55,$55,$55,$55,$55,$55,$55,$5F,$F0,$00,$00,$00,$00,$00,$00,$0C,$03,$FF,$FF,$35,$55,$55,$55,$55,$57
        DB      $FF,$FF,$FF,$D5,$55,$55,$55,$55,$55,$55,$57,$55,$D5,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$EA,$B0,$03,$00,$00,$00,$00,$00,$00,$C0,$03,$FF,$AB,$EA,$FF,$FF,$FF,$FF,$FF
        DB      $EB,$FF,$EA,$D5,$55,$55,$55,$55,$55,$55,$57,$55,$55,$FF,$FA,$AA,$AA,$AA,$AA,$AA,$EA,$AA,$AF,$FC,$00,$00,$00,$00,$00,$00,$00,$00,$FE,$AB,$AA,$AA,$FD,$F0,$00,$03
        DB      $EA,$AA,$AA,$D5,$55,$55,$55,$55,$55,$55,$57,$55,$55,$EA,$AA,$AA,$AA,$AA,$AA,$AA,$EA,$AA,$AA,$BF,$F0,$00,$00,$00,$00,$00,$00,$03,$AA,$AA,$AA,$AA,$AA,$FF,$F0,$03
        DB      $EA,$AA,$AA,$D5,$55,$55,$55,$55,$55,$55,$57,$55,$57,$EA,$AA,$AA,$AA,$AA,$AA,$AA,$6A,$AA,$AA,$C0,$00,$00,$00,$00,$00,$00,$00,$00,$EA,$AA,$AA,$AA,$AA,$AA,$AA,$03
        DB      $EA,$AA,$AA,$D5,$55,$55,$55,$55,$55,$55,$57,$55,$57,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$EA,$AA,$AA,$BF,$C0,$00,$00,$00,$00,$00,$00,$00,$EA,$AA,$AA,$AA,$AA,$AA,$AA,$FF
        DB      $EA,$AA,$AA,$D5,$55,$55,$55,$55,$55,$55,$57,$55,$57,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$EA,$AA,$AA,$AA,$BC,$00,$00,$00,$00,$00,$00,$03,$EA,$AA,$AA,$AA,$AA,$AA,$AA,$AB
        DB      $EA,$AA,$AA,$D5,$55,$55,$55,$55,$55,$55,$57,$55,$57,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$EA,$AA,$AA,$AA,$C0,$00,$00,$00,$00,$00,$00,$0F,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AB
        DB      $EA,$AA,$AA,$D5,$55,$55,$55,$55,$55,$55,$57,$55,$5F,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$6A,$AA,$AA,$AA,$BF,$00,$00,$00,$00,$00,$00,$0E,$AA,$AA,$EA,$AA,$AA,$AA,$AA,$AB
        DB      $EA,$AA,$AA,$D5,$55,$55,$55,$55,$55,$55,$57,$55,$5E,$AA,$AA,$AA,$AA,$AA,$AA,$AB,$FA,$AA,$AA,$AE,$AB,$F0,$00,$00,$00,$00,$00,$3A,$AA,$AF,$0E,$AA,$AA,$AA,$AA,$AB
        DB      $EA,$AA,$AA,$B5,$55,$55,$55,$55,$55,$55,$57,$55,$FA,$AA,$AA,$AA,$AA,$AA,$AA,$AD,$5E,$AA,$AA,$B3,$AC,$00,$00,$00,$00,$00,$00,$3A,$AA,$B0,$C3,$AA,$AA,$AA,$AA,$AB
        DB      $EA,$AA,$AA,$AD,$55,$55,$55,$55,$55,$55,$55,$D7,$EA,$AA,$AA,$AA,$AA,$AA,$AA,$BF,$FF,$AA,$AA,$B3,$AB,$F0,$00,$00,$00,$00,$00,$EA,$AA,$C3,$0E,$AA,$AA,$AA,$AA,$AB
        DB      $EA,$BF,$FF,$AB,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$C3,$FF,$00,$00,$00,$00,$00,$03,$CF,$FF,$C0,$3A,$AA,$AA,$AA,$AA,$AB
        DB      $EA,$EA,$AA,$EA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AF,$FF,$FF,$FE,$AB,$00,$C3,$FF,$F0,$00,$00,$00,$3F,$0C,$0C,$03,$EA,$AA,$AA,$AA,$AA,$AB
        DB      $EB,$AB,$FA,$BA,$AA,$EA,$BF,$AB,$FA,$BF,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$B5,$55,$55,$57,$AC,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$CE,$AA,$AA,$AA,$AA,$AA,$AB
        DB      $EB,$AE,$AE,$BA,$AB,$EA,$EA,$EE,$AE,$EA,$EA,$AA,$AA,$AA,$AA,$AA,$AA,$AB,$55,$55,$55,$55,$73,$3A,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$CE,$AA,$AA,$AA,$AA,$AA,$AB
        DB      $EB,$AE,$AA,$BA,$AA,$EA,$EA,$EE,$AE,$AA,$EA,$AA,$AA,$AA,$AA,$AA,$AA,$B5,$55,$55,$55,$55,$CC,$EA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$FA,$AA,$AA,$AA,$AA,$AA,$AB
        DB      $EB,$AE,$AA,$BA,$AA,$EA,$BF,$EB,$FA,$BF,$AA,$AA,$AA,$AA,$AA,$AA,$AB,$55,$7F,$FF,$FD,$57,$F3,$7A,$AA,$AA,$FF,$FF,$FF,$FF,$FF,$AA,$AA,$EA,$AA,$AA,$AA,$AA,$AA,$AB
        DB      $EB,$AE,$AA,$BA,$AA,$EA,$AA,$EE,$AE,$EA,$AA,$AA,$AA,$AA,$AA,$AA,$B5,$55,$55,$55,$55,$55,$7D,$57,$AF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$AA,$AA,$AA,$AB
        DB      $EB,$AE,$AE,$BA,$AA,$EA,$AB,$AE,$AE,$EA,$AA,$AA,$AA,$AA,$AA,$AB,$55,$55,$55,$55,$55,$55,$55,$55,$7B,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$AA,$BF,$FF,$FA,$AA,$AA,$AB
        DB      $EB,$AB,$FA,$BA,$AB,$FA,$BE,$AB,$FA,$FF,$EA,$AA,$AA,$AA,$AA,$B5,$55,$55,$55,$55,$55,$55,$5F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$AA,$AA,$AA,$AA,$AA,$AA,$AB
        DB      $EA,$EA,$AA,$EA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AB,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$7A,$AA,$AA,$BF,$FF,$FF,$FF,$FE,$AA,$AA,$AA,$AA,$AA,$AA,$AB
        DB      $EA,$BF,$FF,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$B5,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$57,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA,$AB
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55
        DB      $55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$5F,$D7,$57,$5F,$D5,$FD,$75,$77,$FF,$75,$75,$75,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55
        DB      $55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$75,$77,$57,$57,$57,$57,$75,$D7,$55,$7D,$75,$75,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55
        DB      $55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$75,$57,$57,$57,$57,$55,$77,$57,$55,$77,$75,$75,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55
        DB      $55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$75,$57,$FF,$57,$57,$55,$7D,$57,$F5,$75,$F5,$75,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55
        DB      $55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$75,$57,$57,$57,$57,$55,$77,$57,$55,$75,$75,$75,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55
        DB      $55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$75,$77,$57,$57,$57,$57,$75,$D7,$55,$75,$75,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55
        DB      $55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$5F,$D7,$57,$5F,$D5,$FD,$75,$77,$FF,$75,$75,$75,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55
        DB      $55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55
        DB      $55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$5F,$FF,$FF,$FF,$FF,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55
        DB      $55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55
        DB      $55,$55,$55,$55,$55,$55,$55,$56,$AA,$65,$66,$AA,$55,$56,$A9,$5A,$96,$AA,$55,$56,$AA,$5A,$96,$A9,$6A,$96,$55,$6A,$A6,$A9,$5A,$95,$55,$55,$55,$55,$55,$55,$55,$55
        DB      $55,$55,$55,$55,$55,$55,$55,$55,$65,$65,$66,$55,$55,$56,$56,$56,$55,$65,$55,$56,$55,$56,$56,$56,$65,$66,$55,$65,$56,$56,$65,$65,$55,$55,$55,$55,$55,$55,$55,$55
        DB      $55,$55,$55,$55,$55,$55,$55,$55,$65,$65,$66,$55,$55,$56,$56,$56,$55,$65,$55,$56,$55,$56,$56,$56,$65,$66,$55,$65,$56,$56,$65,$55,$55,$55,$55,$55,$55,$55,$55,$55
        DB      $55,$55,$55,$55,$55,$55,$55,$55,$65,$6A,$A6,$A5,$55,$56,$A9,$56,$55,$65,$55,$56,$A5,$56,$56,$56,$65,$66,$55,$6A,$56,$A9,$5A,$95,$55,$55,$55,$55,$55,$55,$55,$55
        DB      $55,$55,$55,$55,$55,$55,$55,$55,$65,$65,$66,$55,$55,$56,$56,$56,$55,$65,$55,$56,$55,$56,$56,$56,$65,$66,$55,$65,$56,$65,$55,$65,$AA,$9A,$5A,$55,$55,$55,$55,$55
        DB      $55,$55,$55,$55,$55,$55,$55,$55,$65,$65,$66,$55,$55,$56,$56,$56,$55,$65,$55,$56,$55,$56,$56,$56,$65,$66,$55,$65,$56,$59,$65,$65,$59,$5A,$AA,$55,$55,$55,$55,$55
        DB      $55,$55,$55,$55,$55,$55,$55,$55,$65,$65,$66,$AA,$55,$56,$A9,$5A,$95,$65,$55,$56,$55,$5A,$96,$A9,$6A,$96,$AA,$6A,$A6,$56,$5A,$95,$59,$59,$A6,$55,$55,$55,$55,$55
        DB      $55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$55,$59,$59,$56,$55,$55,$55,$55,$55

; Enter Here to run Chicken!
L4A28:  LD      A,$08
        OUT     (INMOD),A       ; &(14)=8 for SCREEN INterrupt MODe
        LD      SP,L4FAC        ; set Stack Pointer to RAM top - 24
        SYSTEM  INTPC           ; UPI INTerPret with Context create
        ;
        DONT    EMUSIC          ; UPI End playing MUSIC
        ;
        DONT    ACTINT          ; UPI ACTivate sub timer INTerrupts
        ;
        DO      PAWS            ; UPI PAUSE for 1/2 second
        DB      $1E             ; ... Interrupts = 30
        ;
        DONT    XINTC           ; UPI eXit INTerpreter with Context
        ;
        XOR     A
        OUT     (COL0L),A       ; &(4)=0 for COLor 0 Left to BLACK
        LD      A,$FD
        OUT     (COL2L),A       ; &(6)=253 for COLor 2 Left
        LD      A,$52
        OUT     (COL3L),A       ; &(7)=82 for COLor 3 Left
        LD      A,$07
        OUT     (COL1L),A       ; &(5)=7 for COLor 1 Left
        LD      A,$04
        LD      (L4E39),A       ; set both CHICKENs to 4
        LD      (L4E59),A
        DEC     A
        LD      (L4F63),A       ; set Score Quantum to 3
        LD      (L4C25),A       ; bang MSKTD X Delta to 3
        LD      (L4C28),A       ; bang MSKTD Y Delta to 3
        LD      HL,L4E3B        ; point at P1 BCD SCoRe
        LD      B,A
        XOR     A
        LD      (L4E97),A       ; set DOW to 0 for SUNday
; three passes to set L4E3B thru $4E3D to clear any P1 SCoRe
L4A5F:  LD      (HL),A
        INC     HL
        DJNZ    L4A5F                   ; (-$04)
        LD      B,$03
        LD      HL,L4E5B
; three passes to set L4E5B thru $4E5D to clear any P2 SCoRe
L4A68:  LD      (HL),A
        INC     HL
        DJNZ    L4A68                   ; (-$04)
        LD      A,$80
        LD      (L4E29),A       ; set VBSTATs to 128 for VBSACT (no VBBLNK yet)
        LD      (L4E49),A
        SYSSUK  RECTAN          ; UPI paint a RECTANgle
        DB      $00             ; ... X = 0
        DB      $3A             ; ... Y = 58
        DB      $A0             ; ... Width = 160
        DB      $07             ; ... Height = 7
        DB      $FF             ; ... Color = 255
        ;
        JP      L4D6B           ; to Start a Day

; Continue a Day re-entry point
L4A7E:  CALL    L4DEF           ; do Clear Screen
        LD      A,$82
        OUT     (VERBL),A       ; &(10)=130 for VERtical Blanking pixel Line 65
        SYSSUK  RECTAN          ; UPI paint a RECTANgle
        DB      $00             ; ... X = 0
        DB      $1A             ; ... Y = 26
        DB      $A0             ; ... Width = 160
        DB      $04             ; ... Height = 4
        DB      $AA             ; ... Color = 170 for Color 2 stripe
        ;
        LD      D,$36           ; change Y to 54
        SYSTEM  RECTAN          ; UPI paint a RECTANgle again
        ;
        LD      A,(L4E8C)       ; read Number of Cars value by Day
        LD      B,A
        PUSH    BC
        XOR     A
        CALL    L4B87           ; do Cars facing Left in Bottom 3 Lanes
        LD      A,$40
        POP     BC
        CALL    L4B87           ; then do Cars facing Right in Top Lanes
        LD      IX,L4E28
        CALL    L4BC2           ; do Pattern Draw ?? from Vector Block #1
        LD      IX,L4E48
        CALL    L4BC2           ; do Pattern Draw ?? from Vector Block #2
        SYSSUK  PAWS            ; UPI PAUSE for just over 1 second
        DB      $40             ; ... Interrupts = 64
        ;
        SYSSUK  BMUSIC          ; UPI Begin playing MUSIC #1
        DW      L4F65           ; ... Music Stack = 20325
        DB      $0C             ; ... Voices = 12 for Note C only
        DW      L4DF7           ; ... Score Address = 19959
        ;
L4AB7:  LD      A,$90
        OUT     (VOLN),A        ; &(23)=144 for write VOLume of Noise
        SYSSUK  RANGED          ; UPI RANGED random number
        DB      $00             ; ... Cutoff = None
        ;
        AND     $3F             ; masked to A=0 through 63
        OR      $10             ; now 16 through 63
        LD      (L4DFE+1),A     ; save to MASTER of Score #1 ??
        AND     $1F             ; masked to 16 through 31
        LD      (L4E04),A       ; save in DURATion of a Note ??
        AND     $07             ; now 0 through 7
        OR      $A1             ; now 161 through 167
        LD      (L4DFD),A       ; save as PUSHN in Score #1 ??
        LD      IX,L4E28
        CALL    L4C01           ; do Move ?? using Vector Block #1
        LD      IX,L4E48
        CALL    L4C01           ; do Move ?? using Vector Block #2
        LD      A,$20
        LD      HL,(L4E37)      ; VB #1 Old Pattern ??
        LD      DE,(L4E35)      ; VB %1 Old Address
        HALT
        SYSTEM  WRITR           ; UPI WRITe RELATIVE (Magic = X-OR)
        ;
        LD      HL,(L4E57)      ; VB #2 Old Pattern ??
        LD      DE,(L4E55)      ; VB %2 Old Address
        SYSTEM  WRITR           ; UPI WRITe RELATIVE (Magic = X-OR)
        ;
        LD      HL,L4E94        ; decrement Delay %1 counter (Slowest cars)
        DEC     (HL)
        JR      NZ,L4B08                ; (+$0e) skip until 0
        LD      A,(L4E8D)       ; reset to Delay #1 value (8 to 4)
        LD      (HL),A
        LD      D,$2F
        CALL    L4CC9           ; do Move Cars Right in Row #6 (Outside lanes)
        LD      D,$01
        CALL    L4CF0           ; do Move Cars Left in Row #1
; skip over #1
L4B08:  INC     HL              ; decrement Delay %2 counter (Medium speed)
        DEC     (HL)
        JR      NZ,L4B1A                ; (+$0e) skip until 0
        LD      A,(L4E8E)       ; reset to Delay #2 value (6 to 3)
        LD      (HL),A
        LD      D,$27
        CALL    L4CC9           ; do Move Cars Right in Row #5 (Middle lanes)
        LD      D,$09
        CALL    L4CF0           ; do Move Cars Left in Row #2
; skip over #2
L4B1A:  INC     HL              ; decrement Delay %3 counter (Fastest cars)
        DEC     (HL)
        JR      NZ,L4B2C                ; (+$0e) skip until 0
        LD      A,(L4E8F)       ; reset to Delay #3 value (3 to 2)
        LD      (HL),A
        LD      D,$1F
        CALL    L4CC9           ; do Move Cars Right in Row #4 (Inside lanes)
        LD      D,$12
        CALL    L4CF0           ; do Move Cars Left in Row #3
; skip over #3
L4B2C:  LD      HL,(L4E63)
        CALL    L4C87           ; do Vector Draw pattern in Vector Block #2
        LD      HL,(L4E43)
        LD      IX,L4E28
        CALL    L4C87           ; do Vector Draw pattern in Vector Block #1
        LD      HL,L4E41
        CALL    L4DDD           ; do ??
        JR      Z,L4B4A                 ; (+$06)
        LD      A,$10
        JR      C,L4B4A                 ; (+$02)
        LD      A,$20
L4B4A:  OUT     (TONEA),A       ; &(17)=32 for TONe A oscillator
        LD      HL,L4E61
        CALL    L4DDD           ; do ??
        JR      Z,L4B5A                 ; (+$06)
        LD      A,$30
        JR      C,L4B5A                 ; (+$02)
        LD      A,$15
L4B5A:  OUT     (TONEB),A       ; &(18)=21 for TONe B oscillator
        LD      A,(L4E59)       ; read P2 Chicken counter
        LD      HL,L4E39        ; point at P1 Chicken count
        OR      (HL)
        JR      Z,L4B75                 ; (+$10) if BOTH = 0
        LD      A,(L4E5B)       ; got a P2 BCD SCoRe ?
        OR      (HL)
        JR      Z,L4B75                 ; (+$0a) if ?? = 0 and P1 out
        LD      A,(L4E3B)       ; gotta P1 BCD SCoRe ?
        LD      HL,L4E59        ; point at P2 Chicken counter
        OR      (HL)
        JP      NZ,L4AB7        ; to loop unless ?? = 0 and P2 out
L4B75:  SYSSUK  STRDIS          ; UPI STRing DISplay "GAME OVER"
        DB      $30             ; ... X = 48
        DB      $12             ; ... Y = 18
        DB      $4C             ; ... Options = 76 for 2x Color 3 on Color 0
        DW      L4EF9           ; ... String Address = 20217
        ;
        SYSTEM  EMUSIC          ; UPI End playing MUSIC
        ;
L4B7E:  IN      A,(SW0)         ; &(16) SWitch bank 0 for hand control #1
        BIT     CHTRIG,A        ; bit 4 on player 1 trigger
        JR      Z,L4B7E                 ; (-$06) wait for pull
        JP      L4A28           ; to Run Chicken! again

; Place B = Number of Cars (8 thru 15), A is 0 or 40 for MRFLOP
L4B87:  LD      HL,L4F03        ; clear 0 - 2 pass counter
        LD      (HL),$00
; loop B times (once per Car)
L4B8C:  LD      HL,L4F04        ; point at Lane Y (Left heading) 47, 39, or 31
        PUSH    AF
        AND     A
        JR      Z,L4B96                 ; (+$03) if Not FLOP
        LD      HL,L4F07        ; point at Lane Y (Right) 1, 9 or 18 if FLOP
L4B96:  EX      DE,HL
        LD      HL,L4F03        ; point at pass counter again
        LD      A,(HL)          ; pass 0, 1 or 2
        PUSH    HL
        EX      DE,HL
        SYSTEM  INDEXB          ; UPI INDEX Byte by A
        ;
        LD      D,A             ; save picked number
        POP     HL
        INC     (HL)            ; counter + 1 for next pass
        LD      A,$02
        CP      (HL)
        JR      NC,L4BA9                ; (+$02)
        LD      (HL),$00        ; clear pass 3 to 0
L4BA9:  LD      A,B             ; read Car iteration (B down to 1)
        SYSSUK  INDEXB          ; UPI INDEX Byte by A (0 to 14) ??
        DW      L4F0A           ; ... Base Address = 20234 (off by 1 ??)
        ;
        LD      L,A             ; chooses 60, 20, 80, 40 or 00 for Start X
        LD      H,D             ; number picked above for Lane
        LD      A,B             ; read Car iteration again
        PUSH    HL
        AND     $03
        SYSSUK  INDEXW          ; UPI INDEX Word by A for CARs table
        DW      L4F19           ; ... Base Address = 20249
        ;
        EX      DE,HL
        POP     DE
        POP     AF              ; MR = NO-FLOP or FLOP
        SYSTEM  WRITR           ; UPI WRITe RELATIVE in Lane
        ;
        AND     $F0             ; mask off resultant Shift
        DJNZ    L4B8C                   ; (-$35) for each Car
        RET

; Pattern Draw ?? using L4E28 or L4E48
L4BC2:  LD      A,$01
        LD      (IX+VBYCHK),A   ; +12 set to 1 << VBCLMT
        LD      (IX+$19),A      ; +27 = 1
        LD      (IX+$1F),A      ; +31 =1
        LD      A,(IX+$11)      ; +17
        LD      (IX+$16),A      ; +22 COPY of Chicken Count
        LD      B,A
        LD      DE,$3846
        LD      (IX+VBYH),D     ; +11 = 56
        LD      (IX+VBXH),E     ; +6 = 70
        LD      A,$59
        LD      (L4E4D+1),A     ; reset High byte of VB #2 X to 89 ??
        LD      A,B
        AND     A
        JR      NZ,L4BEB                ; (+$05)
        LD      (IX+$19),$FF    ; +25 = -1
        INC     B
L4BEB:  CALL    L4C57           ; do ??
        LD      A,(IX+$18)      ; +24 read Pattern Magic
; repeat ?? times ??
L4BF1:  PUSH    DE
        SYSTEM  WRITR           ; UPI WRITe RELATIVE
        ;
        POP     DE
        PUSH    AF
        LD      A,E
        SUB     $08
        LD      E,A
        POP     AF
        DJNZ    L4BF1                   ; (-$0c) repeat WRITR
        LD      (IX+$17),E      ; +23
        RET

; Move ?? using L4E28 or L4E48
L4C01:  BIT     VBSACT,(IX+VBSTAT)   ; +1 bit 7 ?
        JR      Z,L4C10                 ; (+$09) if Not ACTive
        LD      A,(IX+$19)
        OR      A
        JR      Z,L4C13                 ; (+$06)
        DEC     (IX+$19)
L4C10:  XOR     A
        JR      L4C22                   ; (+$0f)

L4C13:  LD      C,(IX+$1D)
        IN      A,(C)
        AND     A
        JR      Z,L4C22                 ; (+$07)
        LD      B,$25
; loop ?? 25 times
L4C1D:  DEC     (IX+$1F)
        DJNZ    L4C1D                   ; (-$05)
; ?? entry
L4C22:  LD      B,A
        SYSSUK  MSKTD           ; UPI MaSK joystick in B To Deltas
L4C25:  DB      $03,$00         ; ... X Delta = 0.3 (or 4 or 5)
        DB      $00             ; ... Flop = 0
L4C28:  DB      $03,$00         ; ... Y Delta = 0.3 (or 4 or 5)
        ;
        LD      (IX+VBDYL),L    ; +8 = H.L resultant Delta Y
        LD      (IX+VBDYH),H    ; +9
        LD      (IX+VBDXL),E    ; +3 = D.E resultant Delta X
        LD      (IX+VBDXH),D    ; +4
        LD      (IX+VBTIMB),$08 ; +2 = Fast ??
        LD      H,(IX+VBXH)     ; save +6 in +13
        LD      (IX+$0D),H
        LD      H,(IX+VBYH)     ; save +11 in +14
        LD      (IX+$0E),H
        LD      HL,L4E68
        SYSTEM  VECT            ; UPI VECTor move coordinate pair
        ;
        LD      H,(IX+$1B)
        LD      (IX+$0F),H
        LD      H,(IX+$1C)
        LD      (IX+$10),H
; ?? entry point
L4C57:  LD      A,(IX+$19)
        CP      $80
        JR      C,L4C72                 ; (+$14)
        JR      Z,L4C65                 ; (+$05)
        LD      HL,L4E80        ; point at Splat! pattern
        JR      L4C80                   ; (+$1b)

; ?? = 128
L4C65:  PUSH    IX
        POP     HL
        LD      A,$16           ; +22 COPY of Chicken Count
        ADD     A,L
        LD      L,A
        OR      (HL)
        JP      NZ,L4D48        ; to ?? if ??
        JR      L4C7D                   ; (+$0b) to Chicken

; ?? < 128
L4C72:  DEC     (IX+$1F)
        JP      P,L4C7D
        LD      HL,L4E6C        ; point at Flapping Chicken
        JR      L4C80                   ; (+$03)

; ?? > 128
L4C7D:  LD      HL,L4E78        ; point at 1 Narrow Chicken
L4C80:  LD      (IX+$1B),L
        LD      (IX+$1C),H
        RET

; Vector Draw to ?? or L4E28 ??
L4C87:  LD      A,(IX+VBYH)     ; read +11
        CP      $02
        CALL    Z,L4D28         ; do score and ?? if ??
        IN      A,(INTST)       ; clear &(8) for INTercept STatus
        SYSTEM  VWRITR          ; UPI Vector WRITe Relative
        ;
        LD      A,(IX+VBYH)     ; read +11 again
        CP      $34
        RET     NC
        CP      $20
        JR      NC,L4CA0                ; (+$03)
        CP      $18
        RET     NC
L4CA0:  IN      A,($08)         ; read &(8) for INTercept STatus
        AND     A
        RET     Z
        LD      A,(IX+$19)      ; on Collision, check Chickens
        AND     A
        RET     NZ              ; if any, else ...
        PUSH    IX              ; on None, End round
        SYSSUK  BMUSIC          ; UPI Begin playing MUSIC #2
        DW      L4F65           ; ... Music Stack = 20325
        DB      $0C             ; ... Voices = 12 for Note C only
        DW      L4E16           ; ... Score Address = 19990
        ;
        POP     IX
        LD      (IX+$19),$FF
        DEC     (IX+$11)
        JR      Z,L4CC4                 ; (+$07) if ??
        DEC     (IX+$16)        ; +22 COPY of Chicken Count
        JP      Z,L4D6B         ; to Start a Day if Out of Chickens
        RET

L4CC4:  LD      (IX+VBSTAT),$00 ; +1 = VBBLNK and VBSACT off
        RET

; Move Cars RIGHT in lane D = 31, 39, or 47
L4CC9:  PUSH    HL
        CALL    L4D1C           ; do RelAbs and set loops to 6 Lines
L4CCD:  PUSH    BC
        PUSH    HL
        LD      A,$01
        OUT     (MAGIC),A       ; &(12)=MRSHFT=1 for MAGIC register
        LD      BC,$0027
        LDIR                    ; copy Cars Right 1 pixel
        LD      A,(HL)
        AND     $03
        RRCA
        RRCA
        LD      C,$01
        LDIR                    ; copy 1 byte ?? Right ??
        POP     HL
        OR      (HL)
        LD      (HL),A
        PUSH    DE
        POP     HL
        SET     6,H             ; make non-Magic if less than 16384
        POP     BC
        DJNZ    L4CCD                   ; (-$1e) next Line
        XOR     A
        OUT     (MAGIC),A       ; &(12)=0 for no shift MAGIC register
        POP     HL
        RET

; Move Cars LEFT in lane D = 1, 9 or 12
L4CF0:  PUSH    HL
        CALL    L4D1C           ; do RelAbs and set loops to 6 Lines
L4CF4:  PUSH    BC
        LD      BC,$0027
        LD      A,$03
        OUT     (MAGIC),A       ;&(12)=MRSHFT=3 for MAGIC register
        LD      A,(HL)
        PUSH    AF
        RLCA
        RLCA
        PUSH    HL
        INC     HL
        AND     $FC
        LDIR                    ; copy Cars Left 1 pixel
        PUSH    HL
        POP     BC
        POP     HL
        OR      (HL)
        LD      (HL),A
        PUSH    BC
        POP     HL
        DEC     HL
        POP     AF
        AND     $C0
        LD      (DE),A
        POP     BC
        INC     HL
        INC     DE
        DJNZ    L4CF4                   ; (-$23) next Line
        XOR     A
        OUT     (MAGIC),A       ; &(12)=0 for no shift MAGIC register
        POP     HL
        RET

; RELABS then B = 6 for Car Height loops
L4D1C:  LD      E,$00
        XOR     A
        SYSTEM  RELAB1          ; UPI RELative to non-magic ABSolute
        ;
        PUSH    DE
        POP     HL
        RES     6,D             ; make address Magic if 16384 or over
        LD      B,$06           ; set Distance Cars travel
        RET

; INCrement score and display it
L4D28:  PUSH    IX              ; HL = IX + 19
        POP     HL
        LD      A,L
        ADD     A,$13
        LD      L,A
        LD      A,(L4F63)       ; read Score Quantum
        LD      B,A
L4D33:  SYSTEM  INCSCR          ; UPI INCrement SCoRe + 1
        ;
        DJNZ    L4D33                   ; (-$04) repeat Quantum times
        DEC     HL              ; HL = IX + 18 for X
        LD      E,(HL)
        LD      D,$3A           ; Score Y position = 58
        LD      B,$85           ; Number Options = Zero Suppress 5 digits
        LD      C,$01           ; Options = Color 0 on Color 1
        INC     HL
        SYSTEM  DISNUM          ; UPI DISplay NUMber
        ;
        INC     HL
        INC     HL
        INC     HL
        DEC     (HL)            ; +22 DECrement COPY of Chicken count
        JR      Z,L4D6B                 ; (+$23) to Start a Day if Out
; ?? entry ??
L4D48:  INC     HL              ; HL = IX + 23 for ??
        LD      A,(HL)
        ADD     A,$08
        LD      (HL),A
        LD      E,A
        LD      D,$38
        INC     HL              ; HL = IX + 24 for ??
        LD      A,(HL)
        INC     HL              ; HL = IX + 25 for ??
        LD      (HL),$70
        LD      HL,L4E78        ; point at Sitting Chicken marker
        SYSTEM  WRITR           ; UPI WRITe RELATIVE
        ;
        LD      D,(IX+$1A)
        LD      (IX+VBXH),D     ; +6 = ??
        LD      (IX+VBYH),$38   ; +11 = 56
        LD      (IX+VBYCHK),$01 ; +12 = Y VBCLMT set
        JP      L4C7D

; Start a Day entry point
L4D6B:  LD      SP,L4FAC        ; reset Stack Pointer
        SYSTEM  EMUSIC          ; UPI End playing MUSIC
        ;
        LD      A,(L4E97)       ; read DOW for Day of the Week
        CP      $09
        JP      Z,L4B75         ; to Display "Game Over" and re-Start
        CP      $04
        JR      C,L4D93                 ; (+$17) on Sun/Mon/Tue/Wed
        PUSH    AF
        CP      $07
        JR      C,L4D8A                 ; (+$09) on Thu/Fri/Sat
        LD      A,$05           ; set HOLiday speed
        LD      HL,L4F63
        LD      (HL),$FF        ; save 255 as Score Quantum !!
        JR      L4D8C                   ; (+$02)

L4D8A:  LD      A,$04           ; set END of Week speed
L4D8C:  LD      (L4C28),A       ; bang MSKTD Y Delta to 4 or 5
        LD      (L4C25),A       ; bang MSKTD X Delta to 4 or 5
        POP     AF
L4D93:  PUSH    AF              ; store 1-8 for which Day
        SYSSUK  INDEXW          ; UPI INDEX Word by A (entries 0 & 1 bad ??)
        DW      L4E98           ; ... Base Address = 20120 for Day data
        ;
        LD      HL,L4E8C        ; Day DEstination start address
        LD      BC,$0008
        EX      DE,HL
        LDIR                    ; copy 8 bytes of Day information
        POP     AF
        INC     A
        LD      (L4E97),A       ; save DOW + 1 for Next Day
        PUSH    AF
        SYSSUK  STRDIS          ; UPI STRing DISplay copied "DAY" text
        DB      $44             ; ... X = 68
        DB      $3A             ; ... Y = 58
        DB      $01             ; ... Options = 1 for Color 0 on Color 1
        DW      L4E90           ; ... String Address = 20112
        ;
        CALL    L4DEF           ; do Clear Screen
        LD      HL,L4F63
        SLA     (HL)
        POP     AF
        CP      $01
        JR      Z,L4DD7                 ; (+$1c)
        LD      A,(IX+$11)
        CP      $04             ; all 4 crossed safely in one Day ?
        JR      NZ,L4DD7                ; (+$15) if No
        SYSSUK  STRDIS          ; UPI STRing DISplay "50 Bonus Points"
        DB      $10             ; ... X = 16
        DB      $1E             ; ... Y = 30
        DB      $04             ; ... Options = 4 for Color 1 on Color 0
        DW      L4EE8           ; ... String Address = 20200
        ;
L4DC9:  LD      HL,L4F63
        LD      A,(HL)
        PUSH    AF
        LD      (HL),$32
        CALL    L4D28           ; do Score added 50
        POP     AF
        LD      (L4F63),A
L4DD7:  SYSSUK  PAWS            ; UPI PAUSE for just about a second
        DB      $40             ; ... Interrupts = 64
        ;
        JP      L4A7E           ; to Continue a Day

; ?? using L4E41 or L4E61 ??
L4DDD:  LD      A,(HL)
        AND     A
        JR      NZ,L4DED                ; (+$0c)
        LD      A,$06
        ADD     A,L
        LD      L,A
        LD      A,$F0
        CP      (HL)
        RET     C
        LD      A,(HL)
L4DEA:  CP      $E0
        RET     NC
L4DED:  XOR     A
        RET

; Clear Screen subroutine
L4DEF:  SYSSUK  BLANK           ; UPI BLANK area
        DB      BYTEPL          ; ... Width (in bytes) = 40
        DB      $36             ; ... Height = 54
        DB      $00             ; ... Data = 0
        DW      NORMEM          ; ... Screen Address = 16384
        ;
        RET

; Music Score #1 (with un-Noted note values)
L4DF7:  MASTER  $60             ; not a known octave
        VOLUME  $DD,$2A         ; VA = 13, VB = 13, VC= 10, NM = 2
        LEGSTA                  ; Toggle to STAccato
; loop here until EMUSIC
L4DFD:  PUSHN   $08             ; PUSH Number 8 (or overloaded to ?? ...)
; loop 8 times or so...
L4DFE:  MASTER  $16             ; unknown octave (... changed to ?? ...)
        NOTE1   $18,$6F
        NOTE1   $02,$00
L4E04:  NOTE1   $16,$6F         ; (... and DURATion gets overwritten ??)
        NOTE1   $7F,$00
        NOTE1   $7F,$00
        DSJNZ   L4DFE           ; MUSIC decimal 192 to inside loop
        ;
        NOTE1   $30,$40
        NOTE1   $20,$41
        NOTE1   $02,$00
        JP      L4DFD           ; MUSIC JumP to outside loop

; Music Score #2
L4E16:  MASTER  $10             ; not a known octave
        VOLUME  $00,$2F         ; VA = 0, VB = 0, VC= 15, NM = 2
        LEGSTA                  ; Toggle to STAccato
        NOTE1   $03,$25
        NOTE1   $02,$20
        NOTE1   $02,$18
        NOTE1   $02,$10
        LEGSTA                  ; Toggle to LEGato
        JP      L4DF7           ; MUSIC JumP to Score #1

; extended ?? Vector Block #1
L4E28:  DB      $20             ; VBMR = MRXOR
L4E29:  DB      $C0             ; VBSTAT = VBBLNK and VBSACT
        DB      $00             ; VBTIMB
        DW      $0000           ; VBDX
        DW      $4600           ; VBX
        DB      $03             ; VBXCHK = VBCLMT and VBCREV
        DW      $0000           ; VBDY
        DW      $3800           ; VBY
        DB      $09             ; VBYCHK = VBCLMT and ??
L4E35:  DB      $00             ; +13 VBOAX
        DB      $00             ; +14 VBOAY
L4E37:  DW      $0000           ; +15/16 VBOPattern ??
L4E39:  DB      $00             ; +17 for P1 Chicken count
; more ??
        DB      $18             ; +18 P1 SCoRe X
L4E3B:  DB      $00,$00,$00     ; 3 bytes for P1 BCD SCoRe
        DB      $00             ; +22 copy of Chicken count ??
        DB      $00,$20         ; ??
L4E41:  DW      $4600           ; ?? else ?? init to 1 for ??
L4E43:  DW      $0000           ; +27/28 P1 pattern ??
        DB      $10,$1C
        DB      $00             ; +31 init to 1 for ??
; VB#1 end

 ; extended ?? Vector Block #2
L4E48:  DB      $20             ; VBMR = MRXOR
L4E49:  DB      $C0             ; VBSTAT = VBBLNK and VBSACT
        DB      $00             ; VBTIMB
        DW      $0000           ; VBDX
L4E4D:  DW      $5958           ; VBX (?? or High byte reset to 89 ??)
        DB      $03             ; VBXCHK = VBCLMT and VBCREV
        DW      $0000           ; VBDY
        DW      $3800           ; VBY
        DB      $09             ; VBYCHK = VBCLMT and ??
L4E55:  DB      $00             ; +13 VBOAX
        DB      $00             ; +14 VBOAY
L4E57:  DW      $0000           ; +15/16 VBOPattern ??
L4E59:  DB      $00             ; +17 for P2 Chicken count
; more ??
        DB      $60             ; +18 P2 SCoRe X
L4E5B:  DB      $00,$00,$00     ; 3 bytes for P2 BCD SCoRe
        DB      $00             ; +22 copy of Chicken count ??
        DB      $00,$60
L4E61:  DW      $5900           ; ?? else ?? init to 1 for ??
L4E63:  DW      $0000           ; +27/28 P2 Pattern
        DB      $11,$1D
        DB      $00             ; +31 init to 1 for ??
; VB#2 end

; Vetor Limit table
L4E68:  DB      $04,$9C,$02,$38 ; X = 4 to 156; Y = 2 to 56

; Flapping Chicken color pattern
L4E6C:  DB      $FD             ; X offset = -3
        DB      $FE             ; Y offset = -2
        DB      $02             ; Width in Bytes = 2
        DB      $04             ; Height = 4
        DB      $01,$00         ; . . . 1 . . . .
        DB      $55,$54         ; 1 1 1 1 1 1 1 .
        DB      $15,$50         ; . 1 1(1)1 1 . .
        DB      $05,$40         ; . . 1 1 1 . . .

; Narrow/Sitting Chicken color marker
L4E78:  DB      $FF             ; X offset = -1
        DB      $FE             ; Y offset = -2
        DB      $01             ; Width in Bytes = 1
        DB      $04             ; Height = 4
        DB      $10             ; . 1 . .
        DB      $54             ; 1 1 1 .
        DB      $54             ; 1(1)1 .
        DB      $54             ; 1 1 1 .

; Splat! full color pattern
L4E80:  DB      $FD             ; X offset = -3
        DB      $FE             ; Y offset = -2
        DB      $02             ; Width in Bytes = 2
        DB      $04             ; Height = 4
        DB      $15,$50         ; . 1 1 1 1 1 . .
        DB      $5B,$30         ; 1 1 2 3 . 3 . .
        DB      $49,$C5         ; 1 . 2(1)2 . 1 1
        DB      $13,$15         ; . 1 . 3 . 1 1 1

; 4 bytes used as Day info area (copied from L4E98:)
L4E8C:  DB      $00             ; Number of Cars by Day
L4E8D:  DB      $00             ; Delay #1
L4E8E:  DB      $00             ; Delay #2
L4E8F:  DB      $00             ; Delay #3

; with 4 More bytes of Text area
L4E90:  DB      $00,$00,$00,$00 ; null-terminated

; byte each Delay #1,#2,#3 downcounters
L4E94:  DB      $00,$C3,$28     ; ?? was JP  L4A28 to Run Chicken! (if code ??)

; byte Day of the Week
L4E97:  DB      $4A

; 2 unknown + 8 Days by 8 bytes table (copied to L4E8C:)
L4E98:  DB      $A8,$4E,$B0,$4E,$B8,$4E,$C0,$4E
        DB      $C8,$4E,$D0,$4E,$D8,$4E,$E0,$4E
; 8 more Day data and Text strings
        DB      $08,$08,$06,$03,"SUN",$00
        DB      $09,$08,$05,$03,"MON",$00
        DB      $0A,$07,$04,$03,"TUE",$00
        DB      $0B,$06,$04,$02,"WED",$00
        DB      $0C,$05,$03,$02,"THU",$00
        DB      $0D,$05,$03,$02,"FRI",$00
        DB      $0E,$05,$03,$02,"SAT",$00
        DB      $0F,$04,$03,$02,"HOL",$00

; Bonus text string
L4EE8:  DB      "50 BONUS POINTS!",$00

; Game Over string
L4EF9:  DB      "GAME",$06,"OVER",$00

; Pass Counter 0 through 3 (to Place Cars)
L4F03:  DB      $00

; Left-heading Lanes Y
L4F04:  DB      $2F,$27,$1F

; Right-heading Lanes Y
L4F07:  DB      $01,$09,$12

; Starting X 15 byte table
L4F0A:  DB      $00,$00,$00
        DB      $40,$40,$40
        DB      $80,$80,$80
        DB      $20,$20,$20
        DB      $60,$60,$60

; CARs 4 word table
L4F19:  DW      L4F21
        DW      L4F37
        DW      L4F37           ; duplicated
        DW      L4F4D

; Blue Coupe pattern entry #1
L4F21:  DB      $00             ; X offset = 0
        DB      $00             ; Y offset = 0
        DB      $03             ; Width in Bytes = 3
        DB      $06             ; Height = 6
        DB      $E6,$A9,$A9     ;(3)2 1 2 2 2 2 1 2 2 2 1
        DB      $A6,$A9,$A9     ; 2 2 1 2 2 2 2 1 2 2 2 1
        DB      $56,$A9,$55     ; 1 1 1 2 2 2 2 1 1 1 1 1
        DB      $56,$A9,$55     ; 1 1 1 2 2 2 2 1 1 1 1 1
        DB      $A6,$A9,$A9     ; 2 2 1 2 2 2 2 1 2 2 2 1
        DB      $E6,$A9,$A9     ; 3 2 1 2 2 2 2 1 2 2 2 1

; Red Sedan entries #2 and #3
L4F37:  DB      $00             ; X offset = 0
        DB      $00             ; Y offset = 0
        DB      $03             ; Width in Bytes = 3
        DB      $06             ; Height = 6
        DB      $F7,$FD,$FD     ;(3)3 1 3 3 3 3 1 3 3 3 1
        DB      $77,$FD,$FD     ; 1 3 1 3 3 3 3 1 3 3 3 1
        DB      $77,$FD,$FF     ; 1 3 1 3 3 3 3 1 3 3 3 3
        DB      $77,$FD,$FF     ; 1 3 1 3 3 3 3 1 3 3 3 3
        DB      $77,$FD,$FD     ; 1 3 1 3 3 3 3 1 3 3 3 1
        DB      $F7,$FD,$FD     ; 3 3 1 3 3 3 3 1 3 3 3 1

; Speed Racer entry #4
L4F4D:  DB      $00             ; X offset = 0
        DB      $00             ; Y offset = 0
        DB      $03             ; Width in Bytes = 3
        DB      $06             ; Height = 6
        DB      $D5,$55,$55     ;(3)1 1 1 1 1 1 1 1 1 1 1
        DB      $54,$00,$55     ; 1 1 1 . . . . . 1 1 1 1
        DB      $F4,$00,$7F     ; 3 3 1 . . . . . 1 3 3 3
        DB      $F4,$00,$7F     ; 3 3 1 . . . . . 1 3 3 3
        DB      $54,$00,$55     ; 1 1 1 . . . . . 1 1 1 1
        DB      $D5,$55,$55     ; 3 1 1 1 1 1 1 1 1 1 1 1

; Score Quantum byte
L4F63:  DB      $0C

; L4F64: leftover Music stuff ??
        DB      $02

; Music Stack top (followed by old System Stack)
L4F65:  DB      $00,$00,$00,$00,$00,$00,$00,$00
        DB      $00,$73,$0B,$22,$09,$23,$09,$24
        DB      $09,$1D,$09,$18,$27,$01,$01,$08
        DB      $08,$BD,$26,$26,$08,$18,$27,$01
        DB      $01,$00,$05,$00,$05,$7F,$48,$7A
        DB      $02,$B4,$23,$00,$00,$BD,$26,$BD
        DB      $26,$FC,$05,$7A,$02,$4A,$20,$00
        DB      $00,$BD,$26,$00,$40,$0B,$21,$24
        DB      $21,$54,$20,$9A,$21,$7D,$20
; Top of System Stack here, followed by garbage
L4FAC:  DB      $FF,$00,$00,$04,$EC,$C3,$B1,$4F
        DB      $00,$4A,$19,$4A,$60,$09,$3C,$2C
        DB      $00,$00,$00,$AA,$FA,$78,$4C,$38
        DB      $36,$00,$A3,$52,$07,$00,$19,$00
        DB      $00,$00,$00,$00
; L4FD0: end of garbage
; was: L3000 end of ROM

       END
